
import java.util.*;

/* 
** Grupo.java 
*/

class Grupo {
  private Object [] p;
  private int tam = 0;
  private int marc = -99;

  Grupo () {
    p = new Object [5];  
  }

  Grupo (int n) {
    p = new Object [n];  
  }

  public void aumenta (int m) {
    Object [] novo = new Object [p.length + m];
    for (int i = 0; i < tam; i++) {
      novo[i] = p[i];
    }
    p = novo;
  }

  public void inclui (Object o) {
    if (tam == p.length) {
      aumenta (5);
    }
    p[tam++] = o;
  }

  public Object obtem (Object o) {
    for (int i = 0; i < tam; i++) {
      if (o.equals(p[i])) return p[i];
    }
    return null;
  }

  public Object obtem (int i) {
    if (i >= 0 && i < tam) return p[i];
    return null;
  }

  public void exclui (Object o) {
    for (int i = 0; i < tam;) {
      if (o.equals(p[i])) {
        for (int j = i; j < tam - 1; j++) {
          p[j] = p[j+1];
        }
        tam--;
	  p[tam] = null; 
      } else {
        i++;
      }
    }
  }

  public void exclui () {
     for (int j = marc; j < tam - 1; j++) {
        p[j] = p[j+1];
     }
     tam--;
     p[tam] = null; 
  }

  public int tamanho() {
    return tam;
  }
 
  public void inicio() {
    marc = -1;
  }

  public boolean fim() {
    return tam == 0 || marc == tam;
  }

  public Object proximo() {
    marc++;
    if (!fim()) {
      return p[marc];
    } else {
      inicio();
      return null;
    }
  }

  public String toString() {
    String s = "";
    for (int i = 0; i < tam; i++) {
      s += p[i] + "\n";
    }
    return s;
  }

  public void ordena (Comparator c, int ordem ) {
     /* 
        ordem negativo -> ordenacao decrescente
        ordem positivo -> ordenacao crescente
     */
        
     for (int j = 0; j < tam; j++) {
       for (int i = 0; i < tam-1; i++) {
          if (c.compare(p[i],p[i+1])*ordem > 0) {
            Object aux = p[i];
            p[i] = p[i+1];
            p[i+1] = aux;
          }
       }
     }
  }       

  private abstract class IteradorGrupo implements Iterator {

     abstract void avancaMarcador();

     public Object next() {
       if (hasNext()) {
         avancaMarcador();
         return p[marc];
       } else {
         return null;
       }
     }

     public void remove() {
        for(int j = marc; j < tam - 1; j++){
          p[j] = p[j+1];
        }
        p[tam - 1] = null;
        tam--;
     }
  }

  private class IteradorAscendente extends IteradorGrupo {

     private IteradorAscendente() {
       marc = tam > 0 ?  -1 : -99;
     }

     public boolean hasNext() {
       return !(marc == tam - 1 || marc == -99);
     }

     void avancaMarcador() {
       ++marc;
     }
  }

  public Iterator iteradorAscendente() {
     return new IteradorAscendente();
  }

  private class IteradorDescendente extends IteradorGrupo {

     private IteradorDescendente() {
       marc = tam > 0 ?  tam : -99;
     }

     public boolean hasNext() {
       return !(marc == 0 || marc == -99);
     }

     void avancaMarcador() {
       --marc;
     }
  }

  public Iterator iteradorDescendente() {
     return new IteradorDescendente();
  }

  private abstract class IteradorPassoDuplo extends IteradorGrupo {

     public boolean hasNext() {
       return !(marc > tam - 3 || 
 marc == -99);
     }

     void avancaMarcador() {
       marc = marc + 2;
     }
  }

  private class IteradorPar extends IteradorPassoDuplo {

     private IteradorPar() {
       marc = tam > 0 ?  -1 : -99;
     }
  }

  public Iterator iteradorPar() {
     return new IteradorPar();
  }

  private class IteradorImpar 
extends IteradorPassoDuplo {

     private IteradorImpar() {
       marc = tam > 0 ?  -2 : -99;
     }
  }

  public Iterator iteradorImpar() {
     return new IteradorImpar();
  }

}

public class UsaIterador { 
   static Random rand = new Random(); 
   static int pRand(int mod) {
     return 1 + Math.abs(rand.nextInt()) % mod;
   }

   public static void main (String[] args) {
     System.out.print("Entre com o tamanho do grupo: ");
     int n = Console.readInteger();
     Grupo gp = new Grupo(n);
     for (int i = 0; i < n; i++) {
       gp.inclui(new Integer(pRand(9)));
     }
     System.out.println(gp);
     Iterator i;
     System.out.print("Entre com o tipo de ordenacao (1 a 4): ");
     int o = Console.readInteger();
     switch (o) {
       default:
       case 1:
        i = gp.iteradorAscendente();
        System.out.println("Ascendente");
        break;
       case 2: 
        i = gp.iteradorPar();
        System.out.println("Pares");
        break;
       case 3:      
        i = gp.iteradorImpar();
        System.out.println("Impares");
        break;
       case 4: 
        i = gp.iteradorDescendente();
        System.out.println("Descendente");
     } 
     while (i.hasNext()) {
	   System.out.println(i.next());
     }
   }
}    
